---
title: Request.mode
slug: Web/API/Request/mode
tags:
  - API
  - Experimental
  - Fetch
  - Property
  - Reference
  - mode
  - request
---
<div>{{APIRef("Fetch")}}</div>

<p>The <strong><code>mode</code></strong> read-only property of the {{domxref("Request")}} interface contains the mode of the request (e.g., <code>cors</code>, <code>no-cors</code>, <code>same-origin</code>, or <code>navigate</code>.) This is used to determine if cross-origin requests lead to valid responses, and which properties of the response are readable.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">var <var>myMode</var> = <var>request</var>.mode;</pre>

<h3 id="Value">Value</h3>

<dl>
 <dt>
 <p>A <code>RequestMode</code> value.</p>
 </dt>
 <dd>
 <p>The associated <dfn>mode</dfn>, available values of which are:</p>

 <ul>
  <li><code>same-origin</code> — If a request is made to another origin with this mode set, the result is an error. You could use this to ensure that a request is always being made to your origin.</li>
  <li><code>no-cors</code> — Prevents the method from being anything other than <code>HEAD</code>, <code>GET</code> or <code>POST</code>, and the headers from being anything other than <a href="https://fetch.spec.whatwg.org/#simple-header">simple headers</a>. If any ServiceWorkers intercept these requests, they may not add or override any headers except for those that are <a href="https://fetch.spec.whatwg.org/#simple-header">simple headers</a>. In addition, JavaScript may not access any properties of the resulting {{domxref("Response")}}. This ensures that ServiceWorkers do not affect the semantics of the Web and prevents security and privacy issues arising from leaking data across domains.</li>
  <li><code>cors</code> — Allows cross-origin requests, for example to access various APIs offered by 3rd party vendors. These are expected to adhere to the <a href="/en-US/docs/Web/HTTP/Access_control_CORS">CORS protocol</a>. Only a <a href="https://fetch.spec.whatwg.org/#concept-filtered-response-cors">limited set</a> of headers are exposed in the {{domxref("Response")}}, but the body is readable.</li>
  <li><code>navigate</code> — A mode for supporting navigation. The <code>navigate</code> value is intended to be used only by HTML navigation. A navigate request is created only while navigating between documents.</li>
 </ul>
 </dd>
</dl>

<h4 id="Default_mode">Default mode</h4>

<p>Requests can be initiated in a variety of ways, and the mode for a request depends on the particular means by which it was initiated.</p>

<p>For example, when a <code>Request</code> object is created using the {{domxref("Request.Request")}} constructor, the value of the <code>mode</code> property for that <code>Request</code> is set to <code>cors</code>.</p>

<p>However, for requests created other than by the {{domxref("Request.Request")}} constructor, <code>no-cors</code> is typically used as the mode; for example, for embedded resources where the request is initiated from markup, unless the <code><a href="/en-US/docs/Web/HTML/CORS_settings_attributes">crossorigin</a></code> attribute is present, the request is in most cases made using the <code>no-cors</code> mode — that is, for the {{HTMLElement("link")}} or {{HTMLElement("script")}} elements (except when used with modules), or {{HTMLElement("img")}}, {{HTMLElement("audio")}}, {{HTMLElement("video")}}, {{HTMLElement("object")}}, {{HTMLElement("embed")}}, or {{HTMLElement("iframe")}} elements.</p>

<h2 id="Example">Example</h2>

<p>In the following snippet, we create a new request using the {{domxref("Request.Request()")}} constructor (for an image file in the same directory as the script), then save the request mode in a variable:</p>

<pre class="brush: js">var myRequest = new Request('flowers.jpg');
var myMode = myRequest.mode; // returns "cors" by default</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('Fetch','#dom-request-mode', 'mode')}}</td>
   <td>{{Spec2('Fetch')}}</td>
   <td>Initial definition</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.Request.mode")}}</p>


<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/ServiceWorker_API">ServiceWorker API</a></li>
 <li><a href="/en-US/docs/Web/HTTP/Access_control_CORS">HTTP access control (CORS)</a></li>
 <li><a href="/en-US/docs/Web/HTTP">HTTP</a></li>
</ul>
